## docker.io 18.06.1+dfsg1

=== Makefile ===
# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
DESTDIR=/usr/local

# Used to populate version variable in main package.
VERSION=$(shell git describe --match 'v[0-9]*' --dirty='.m' --always)

PROJECT_ROOT=github.com/docker/swarmkit

# Race detector is only supported on amd64.
RACE := $(shell test $$(go env GOARCH) != "amd64" || (echo "-race"))

# Project packages.
PACKAGES=$(shell go list ./... | grep -v /vendor/)
INTEGRATION_PACKAGE=${PROJECT_ROOT}/integration

# Project binaries.
COMMANDS=swarmd swarmctl swarm-bench swarm-rafttool protoc-gen-gogoswarm
BINARIES=$(addprefix bin/,$(COMMANDS))

VNDR=$(shell which vndr || echo '')

GO_LDFLAGS=-ldflags "-X `go list ./version`.Version=$(VERSION)"

.PHONY: clean all AUTHORS fmt vet lint build binaries test integration setup generate protos checkprotos coverage ci check help install uninstall dep-validate
.DEFAULT: default

all: check binaries test integration ## run fmt, vet, lint, build the binaries and run the tests

check: fmt vet lint ineffassign misspell ## run fmt, vet, lint, ineffassign, misspell

ci: check binaries checkprotos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

setup: ## install dependencies
	@echo "🐳 $@"
	# TODO(stevvooe): Install these from the vendor directory
	@go get -u github.com/golang/lint/golint
	#@go get -u github.com/kisielk/errcheck
	@go get -u github.com/gordonklaus/ineffassign
	@go get -u github.com/client9/misspell/cmd/misspell
	@go get -u github.com/lk4d4/vndr
	@go get -u github.com/stevvooe/protobuild

generate: protos
	@echo "🐳 $@"
	@PATH=${ROOTDIR}/bin:${PATH} go generate -x ${PACKAGES}

protos: bin/protoc-gen-gogoswarm ## generate protobuf
	@echo "🐳 $@"
	@PATH=${ROOTDIR}/bin:${PATH} protobuild ${PACKAGES}

checkprotos: generate ## check if protobufs needs to be generated again
	@echo "🐳 $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "👹 please run 'make generate' when making changes to proto files" && false))

# Depends on binaries because vet will silently fail if it can't load compiled
# imports
vet: binaries ## run go vet
	@echo "🐳 $@"
	@test -z "$$(go vet ${PACKAGES} 2>&1 | grep -v 'constant [0-9]* not a string in call to Errorf' | egrep -v '(timestamp_test.go|duration_test.go|exit status 1)' | tee /dev/stderr)"

misspell:
	@echo "🐳 $@"
	@test -z "$$(find . -type f | grep -v vendor/ | grep -v bin/ | grep -v .git/ | grep -v MAINTAINERS | xargs misspell | tee /dev/stderr)"

fmt: ## run go fmt
	@echo "🐳 $@"
	@test -z "$$(gofmt -s -l . | grep -v vendor/ | grep -v ".pb.go$$" | tee /dev/stderr)" || \
		(echo "👹 please format Go code with 'gofmt -s -w'" && false)
	@test -z "$$(find . -path ./vendor -prune -o ! -name timestamp.proto ! -name duration.proto -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "👹 please indent proto files with tabs only" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "Meta meta = " {} \; | grep -v '(gogoproto.nullable) = false' | tee /dev/stderr)" || \
		(echo "👹 meta fields in proto files must have option (gogoproto.nullable) = false" && false)

lint: ## run go lint
	@echo "🐳 $@"
	@test -z "$$(golint ./... | grep -v vendor/ | grep -v ".pb.go:" | tee /dev/stderr)"

ineffassign: ## run ineffassign
	@echo "🐳 $@"
	@test -z "$$(ineffassign . | grep -v vendor/ | grep -v ".pb.go:" | tee /dev/stderr)"

#errcheck: ## run go errcheck
#	@echo "🐳 $@"
#	@test -z "$$(errcheck ./... | grep -v vendor/ | grep -v ".pb.go:" | tee /dev/stderr)"

build: ## build the go packages
	@echo "🐳 $@"
	@go build -i -tags "${DOCKER_BUILDTAGS}" -v ${GO_LDFLAGS} ${GO_GCFLAGS} ${PACKAGES}

test: ## run tests, except integration tests
	@echo "🐳 $@"
	@go test -parallel 8 ${RACE} -tags "${DOCKER_BUILDTAGS}" $(filter-out ${INTEGRATION_PACKAGE},${PACKAGES})

integration: ## run integration tests
	@echo "🐳 $@"
	@go test -parallel 8 ${RACE} -tags "${DOCKER_BUILDTAGS}" ${INTEGRATION_PACKAGE}

FORCE:

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	@test $$(go list) = "${PROJECT_ROOT}" || \
		(echo "👹 Please correctly set up your Go build environment. This project must be located at <GOPATH>/src/${PROJECT_ROOT}" && false)
	@echo "🐳 $@"
	@go build -i -tags "${DOCKER_BUILDTAGS}" -o $@ ${GO_LDFLAGS}  ${GO_GCFLAGS} ./$<

binaries: $(BINARIES) ## build binaries
	@echo "🐳 $@"

clean: ## clean up binaries
	@echo "🐳 $@"
	@rm -f $(BINARIES)

install: $(BINARIES) ## install binaries
	@echo "🐳 $@"
	@mkdir -p $(DESTDIR)/bin
	@install $(BINARIES) $(DESTDIR)/bin

uninstall:
	@echo "🐳 $@"
	@rm -f $(addprefix $(DESTDIR)/bin/,$(notdir $(BINARIES)))

coverage: ## generate coverprofiles from the unit tests
	@echo "🐳 $@"
	@( for pkg in $(filter-out ${INTEGRATION_PACKAGE},${PACKAGES}); do \
		go test -i ${RACE} -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../$$pkg/coverage.txt" -covermode=atomic $$pkg || exit; \
		go test ${RACE} -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../$$pkg/coverage.txt" -covermode=atomic $$pkg || exit; \
	done )

coverage-integration: ## generate coverprofiles from the integration tests
	@echo "🐳 $@"
	go test ${RACE} -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../${INTEGRATION_PACKAGE}/coverage.txt" -covermode=atomic ${INTEGRATION_PACKAGE}

help: ## this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST) | sort

dep-validate:
	@echo "+ $@"
	$(if $(VNDR), , \
		$(error Please install vndr: go get github.com/lk4d4/vndr))
	@rm -Rf .vendor.bak
	@mv vendor .vendor.bak
	@$(VNDR)
	@test -z "$$(diff -r vendor .vendor.bak 2>&1 | tee /dev/stderr)" || \
		(echo >&2 "+ inconsistent dependencies! what you have in vendor.conf does not match with what you have in vendor" && false)
	@rm -Rf vendor
	@mv .vendor.bak vendor

=== debian/changelog ===
docker.io (18.06.1+dfsg1-2+rpi1) buster-staging; urgency=medium

  * Disable testsuite.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 26 Jan 2019 01:54:38 +0000

docker.io (18.06.1+dfsg1-2) unstable; urgency=medium

  * Tighten versioned dependency on "runc".
  * dev: install "libnetwork/ipamutils".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 16 Sep 2018 13:21:33 +1000

docker.io (18.06.1+dfsg1-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream release [August 2018].
  * Upload to unstable (Closes: #906999).

  [ Arnaud Rebillout ]
  * Cleanup /etc/init/docker.conf (Closes: #907455)

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 11 Sep 2018 14:03:46 +1000

docker.io (18.06.0+dfsg1-1) experimental; urgency=medium

  * New upstream release [July 2018].

  [ Arnaud Rebillout ]
  * get-orig-source: print the list of directories vendored by upstream.

  [ Dmitry Smirnov ]
  * README.source: noted duration of upstream support.
  * README.Debian: added note about restart dilemma.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 10 Aug 2018 19:07:41 +1000

docker.io (18.03.1+dfsg1-6) unstable; urgency=medium

  * Removed obsolete "golang-ed25519-dev" from Build-Depends.
  * Standards-Version: 4.1.5.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 11 Jul 2018 20:15:24 +1000

docker.io (18.03.1+dfsg1-5) unstable; urgency=medium

  * New upstream patch to prevent needless calls to `pass` (Closes: #902258).
  * Do not automatically restart daemon on upgrade (Closes: #786724).
  * Recommends += "needrestart".

    "needrestart" prompts to restart "docker" daemon on upgrade. This way
    running containers won't be killed on upgrade until user choses to
    restart Docker.
    Not restarting Docker on upgrade may break CLI when it disagrees with
    running daemon regarding API version.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 02 Jul 2018 14:56:46 +1000

docker.io (18.03.1+dfsg1-4) unstable; urgency=medium

  * Suggests += "e2fsprogs, xfsprogs" (Closes: #887222).
  * rules: fixed test failure on binary-indep build (Closes: #902206).
    Thanks, Santiago Vila.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 24 Jun 2018 23:22:51 +1000

docker.io (18.03.1+dfsg1-3) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Replaced upstream SysV init file with an improved one.
      * --remove-pidfile on stop (Closes: #764921)
      * don't fail when removed (Closes: #841282)
      * fixed exit status:
          + don't fail to stop when already stopped
          + don't fail to start when already started
      * removed useless check_init()
    Thanks, Sam Morris.
  * postinst: create "docker" group when needed (Closes: #821078).
  * README.source: added comment to clarify upstream version numbering.
    Thanks, Tianon Gravi
  * README.source: added link describing upstream life cycle & release
    policy. Thanks, Tianon Gravi.

  [ Arnaud Rebillout ]
  * Added myself to uploaders.
  * Bumped compat to 11 to allow installling the systemd socket
    file automatically with dh_installsystemd.
  * Installed systemd socket through dh_installsystemd.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 21 Jun 2018 21:27:32 +1000

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.1.5
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Arnaud Rebillout <arnaud.rebillout@collabora.com>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
#Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper (>= 11~) ,dh-exec ,dh-golang (>= 1.14~)
    ,bash-completion,
    ,ca-certificates
    ,git
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,gogoprotobuf, libprotobuf-dev
    ,golang-dbus-dev (>= 4.1.0~)
    ,golang-etcd-server-dev
#   ,golang-github-appc-cni-dev (>= 0.6.0~)
    ,golang-github-armon-go-metrics-dev
    ,golang-github-aws-aws-sdk-go-dev
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-blang-semver-dev
    ,golang-github-boltdb-bolt-dev
    ,golang-github-bshuster-repo-logrus-logstash-hook-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cloudflare-cfssl-dev
    ,golang-github-containerd-btrfs-dev (>= 0.0~git20180306~)
    ,golang-github-containerd-cgroups-dev
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-fifo-dev
    ,golang-github-containerd-go-runc-dev
    ,golang-github-containerd-typeurl-dev
    ,golang-github-coreos-go-systemd-dev (>= 17~)
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-denverdino-aliyungo-dev
    ,golang-github-dgrijalva-jwt-go-dev
    ,golang-github-dgrijalva-jwt-go-v3-dev
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-goamz-dev
    ,golang-github-docker-go-connections-dev (>= 0.3.0~)
    ,golang-github-docker-go-dev
    ,golang-github-docker-go-units-dev (>= 0.3.1+git20161130.10.e30f1e7)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev (>= 0.6.1~) | golang-github-theupdateframework-notary-dev
    ,golang-github-docker-spdystream-dev
    ,golang-github-emicklei-go-restful-dev
    ,golang-github-emicklei-go-restful-swagger12-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-flynn-archive-go-shlex-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-garyburd-redigo-dev
    ,golang-github-ghodss-yaml-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-gofuzz-dev
    ,golang-github-google-shlex-dev
    ,golang-github-go-openapi-jsonpointer-dev
    ,golang-github-go-openapi-jsonreference-dev
    ,golang-github-go-openapi-spec-dev
    ,golang-github-go-openapi-swag-dev
    ,golang-github-gorilla-context-dev
    ,golang-github-gorilla-mux-dev
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
#   ,golang-github-grpc-ecosystem-grpc-gateway-dev
    ,golang-github-hashicorp-go-msgpack-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
#   ,golang-github-juju-ratelimit-dev
    ,golang-github-kr-pty-dev
#   ,golang-github-mailru-easyjson-dev
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-mattn-go-sqlite3-dev
    ,golang-github-miekg-dns-dev
    ,golang-github-miekg-pkcs11-dev
    ,golang-github-mitchellh-hashstructure-dev
#   ,golang-github-modern-go-concurrent-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-mrunalp-fileutils-dev
    ,golang-github-ncw-swift-dev
#~  ,golang-github-nvveen-gotty-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc5~)
    ,golang-github-opencontainers-selinux-dev
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev
    ,golang-github-pborman-uuid-dev
    ,golang-github-peterbourgon-diskv-dev (>= 2.0.1~)
    ,golang-github-philhofer-fwd-dev
    ,golang-github-pivotal-golang-clock-dev
    ,golang-github-pmezard-go-difflib-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-rcrowley-go-metrics-dev
    ,golang-github-rsc-letsencrypt-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.0)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-spf13-cobra-dev (>= 0.0.2~)
    ,golang-github-stevvooe-ttrpc-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-github-tinylib-msgp-dev
    ,golang-github-tonistiigi-fifo-dev
    ,golang-github-ugorji-go-codec-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vaughan0-go-ini-dev
    ,golang-github-vbatts-tar-split-dev
    ,golang-github-vdemeester-shakers-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
    ,golang-github-xenolf-lego-dev
#   ,golang-glog-dev
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-goprotobuf-dev (>= 0.0~git20151207~)
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,libapparmor-dev
    ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
    ,libdevmapper-dev
    ,pkg-config
    ,procps
    ,tzdata
Homepage: https://dockerproject.org
Vcs-Browser: https://salsa.debian.org/docker-team/docker
Vcs-Git: https://salsa.debian.org/docker-team/docker.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: linux-any
Depends: ${misc:Depends} ,${perl:Depends} ,${shlibs:Depends}
    ,adduser
    ,iptables
    ,lsb-base
    ,runc (>= 1.0.0~rc5~)
    ,tini
Recommends: ${apparmor:Recommends}
    ,ca-certificates
    ,cgroupfs-mount
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Replaces: docker (<< 1.5~) ,docker-containerd ,docker-runc ,golang-libnetwork
Breaks: docker (<< 1.5~) ,docker-containerd ,docker-runc ,golang-libnetwork
Conflicts: docker-containerd ,docker-runc ,golang-libnetwork
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,xfsprogs
    ,zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-docker-distribution-dev
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev
    ,golang-github-docker-go-units-dev
    ,golang-github-docker-libkv-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-gorilla-mux-dev
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
    ,golang-github-opencontainers-selinux-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-stretchr-testify-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
# libnetwork:
    ,golang-dbus-dev (>= 3~)
    ,golang-github-burntsushi-toml-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-gogo-protobuf-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
    ,golang-github-docker-libnetwork-dev
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
    ,golang-github-docker-libnetwork-dev
Provides: golang-github-docker-libnetwork-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

#Package: golang-github-opencontainers-docker-runc-dev
#Section: oldlibs
#Architecture: all
#Depends: ${misc:Depends}
#    ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
#Description: Open Container Project - development files (Docker's version)
# This is a transitional package to ease upgrades to the
# "golang-github-opencontainers-runc-dev" package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

## Disable compiler cache (`go env GOCACHE`, `go help cache`).
export GOCACHE=off

export HOME=$(CURDIR)/debian/tmp

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    vendor

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)

export DOCKER_VERSION := $(shell cat VERSION)
export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
ifndef DOCKER_GITCOMMIT
  $(error Missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits)
endif

export BUILDTIME := $(shell dpkg-parsechangelog -SDate)

# have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs (we clean it up appropriately ourselves)
export KEEPBUNDLE := 1

## AppArmor can be optionally used in Debian and is there by default in Ubuntu,
## so we need support for it compiled into our binary same story with SELinux.
export DOCKER_BUILDTAGS := apparmor seccomp selinux ambient

## prefer Go 1.7 explicitly if it's available (golang-1.7-go)
#export PATH := /usr/lib/go-1.7/bin:$(PATH)

APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=.gopath

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(OUR_GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/cli
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/docker
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/libnetwork
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/swarmkit
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/distribution
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/go-events
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/go-metrics
	mkdir -pv $(OUR_GOPATH)/src/github.com/containerd/containerd

#	## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/cli
	cp -ra  cli           $(OUR_GOPATH)/src/github.com/docker/cli

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/docker
	cp -ra  engine        $(OUR_GOPATH)/src/github.com/docker/docker

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/libnetwork
	cp -ra  libnetwork    $(OUR_GOPATH)/src/github.com/docker/libnetwork

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/swarmkit
	cp -ra  swarmkit      $(OUR_GOPATH)/src/github.com/docker/swarmkit

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/distribution
	cp -ra  distribution  $(OUR_GOPATH)/src/github.com/docker/distribution

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/go-events
	cp -ra  go-events     $(OUR_GOPATH)/src/github.com/docker/go-events

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/go-metrics
	cp -ra  go-metrics    $(OUR_GOPATH)/src/github.com/docker/go-metrics

	$(RM) -r              $(OUR_GOPATH)/src/github.com/containerd/containerd
	cp -ra  containerd    $(OUR_GOPATH)/src/github.com/containerd/containerd

#	cp -ra  containerd/vendor/github.com/containerd/continuity    $(OUR_GOPATH)/src/github.com/containerd/
#	cp -ra  engine/vendor/github.com/docker/distribution          $(OUR_GOPATH)/src/github.com/docker/

override_dh_auto_build-indep:
	# noop

override_dh_auto_build-arch:
## order is important:

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/distribution"    dh_auto_build -v

	DH_GOPKG="github.com/docker/libnetwork"                dh_auto_build -v

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/swarmkit"        dh_auto_build -v

	export DH_GOPKG="github.com/containerd/containerd" ;\
        export REV="`grep $${DH_GOPKG} engine/vendor.conf | head -1 | awk '{print $$2}'`" ;\
        dh_auto_build -v -- -tags "$(DOCKER_BUILDTAGS)" \
          -ldflags "-X $${DH_GOPKG}/version.Version=$(DOCKER_VERSION) -X $${DH_GOPKG}/version.Revision=$${REV}"

	DH_GOPKG="github.com/docker/go-events"                 dh_auto_build -v
	DH_GOPKG="github.com/docker/go-metrics"                dh_auto_build -v
	
##	build ("cd" first to ensure we build from within GOPATH)
	cd '$(OUR_GOPATH)/src/github.com/docker/docker' \
        && VERSION=$(DOCKER_VERSION) ./hack/make.sh dynbinary
	
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 LDFLAGS='' \
           $(MAKE) VERSION=$(DOCKER_VERSION) GITCOMMIT=$(DOCKER_GITCOMMIT) dynbinary manpages
	
#	# compile man pages
#	./man/md2man-all.sh -q

override_dh_auto_test-indep:
	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        #dh_auto_test -v --max-parallel=4 -- -short

override_dh_auto_test-arch:
###     [[[ DO NOT DISABLE TESTS ]]]  [[[ DO *NOT* DISABLE TESTS ]]]
	#DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        #dh_auto_test -v --max-parallel=4 -- -short
ifeq (testsuitedisabled,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	## Test engine:
#	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
#        && TESTFLAGS='-test.short' ./hack/make.sh test-unit
	cd $(OUR_GOPATH)/src/github.com/docker/docker \
        && TESTFLAGS='-test.short' ./hack/test/unit

	## Test CLI:
	cd $(OUR_GOPATH)/src/github.com/docker/cli \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit

	.gopath/bin/containerd -version
endif

override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install/dh-exec for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol
